/*
 * This file is part of the internal font implementation.  It should not be included by anyone other than
 * FontMac.cpp, FontWin.cpp and Font.cpp.
 *
 * Copyright (C) 2006, 2007, 2008 Apple Inc.
 * Copyright (C) 2008 Brent Fulgham
 * Copyright     2008, 2009 Sony Corporation
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 */

#include "config.h"

#if USE(SILK_CEUIFONT)

#include "FontPlatformData.h"

#include "PlatformString.h"
#include "StringHash.h"
#include <wtf/HashMap.h>
#include <wtf/Vector.h>

namespace WebCore {

FontPlatformData::~FontPlatformData()
{
}

FontPlatformData::FontPlatformData(float size, bool bold, bool oblique)
: m_pfFont(0)
, m_size(size)
, m_syntheticBold(bold)
, m_syntheticOblique(oblique)
{
}

//! ctor() to create page-zero physical font data.
FontPlatformData::FontPlatformData(ICEUIPlatformFontRef pfFontRef, float size, bool bold, bool oblique)
: m_pfFont(RefCountedICEUIPlatformFont::create(pfFontRef))
, m_size(size)
, m_syntheticBold(bold)
, m_syntheticOblique(oblique)
{
}

} // namespace


#else //#if !USE(SILK_CEUIFONT)
bad config.
#endif //#if !USE(SILK_CEUIFONT)
