///////////////////////////////////////////////////////////////////////////////
// Copyright 2004,2009 Sony Corporation
///////////////////////////////////////////////////////////////////////////////

#ifndef __CESysTarget_linux_h__
#define __CESysTarget_linux_h__


/////////////////////////////////////////////
// Compiler
/////////////////////////////////////////////

#if !defined(CESYS_COMPILER_H)
#define CESYS_COMPILER_H "CESysCompilerGCC.h"
#endif


/////////////////////////////////////////////
// Existing C/C++ header files
/////////////////////////////////////////////

// included in CESysDefs.h
#if !defined(CE_HAVE_STDDEF_H)
#define CE_HAVE_STDDEF_H 1
#endif

#if !defined(CE_HAVE_STDINT_H)
#define CE_HAVE_STDINT_H 1
#endif

#if !defined(CE_HAVE_LIMITS_H)
#define CE_HAVE_LIMITS_H 1
#endif

#if !defined(CE_HAVE_STDARG_H)
#define CE_HAVE_STDARG_H 1
#endif

#if !defined(CE_HAVE_CTYPE_H)
#define CE_HAVE_CTYPE_H 1
#endif

#if !defined(CE_HAVE_STRING_H)
#define CE_HAVE_STRING_H 1
#endif

#if !defined(CE_HAVE_STDIO_H)
#define CE_HAVE_STDIO_H 1
#endif

#if !defined(CE_HAVE_STDLIB_H)
#define CE_HAVE_STDLIB_H 1
#endif

#if !defined(CE_HAVE_FLOAT_H)
#define CE_HAVE_FLOAT_H 1
#endif

#if !defined(CE_HAVE_MATH_H)
#define CE_HAVE_MATH_H 1
#endif

#if !defined(CE_HAVE_MALLOC_H)
#define CE_HAVE_MALLOC_H 1
#endif

#if !defined(CE_HAVE_NEW)
#define CE_HAVE_NEW 1
#endif

#if !defined(CE_HAVE_STRCASECMP)
#define CE_HAVE_STRCASECMP 1
#endif

#if !defined(CE_HAVE_LROUND)
#define CE_HAVE_LROUND 1
#endif


/////////////////////////////////////////////
// OS-dependent definitions
/////////////////////////////////////////////

#define CESYS_OSDEFS_H "CESysOSDefsLinux.h"


////////////////////////////////////////////////
//  Syswrap System Dependent Header Files
////////////////////////////////////////////////

#if !defined(CESYSATOMICOPS_TARGET_H)
#define CESYSATOMICOPS_TARGET_H "CESysAtomicOpsLinux.h"
#endif

#if !defined(CESYSCONFIG_TARGET_H)
#define CESYSCONFIG_TARGET_H "CESysConfigLinux.h"
#endif

#if !defined(CESYSCRITICALSECTION_TARGET_H)
#define CESYSCRITICALSECTION_TARGET_H "CESysCriticalSectionLinux.h"
#endif

#if !defined(CESYSGETTIMEOFDAY_TARGET_H)
#define CESYSGETTIMEOFDAY_TARGET_H "CESysGetTimeOfDayLinux.h"
#endif

#if !defined(CESYSSOCKET_TARGET_H)
#define CESYSSOCKET_TARGET_H "CESysSocketLinux.h"
#endif


/////////////////////////////////////////////
// Target-dependent features
/////////////////////////////////////////////

#if !defined(CE_USE_INTERNAL_PROFILER)
#define CE_USE_INTERNAL_PROFILER 1
#endif

/*!
* use i18n icu4c binding.
*/
#if !defined(USE_CEI18N_ICU)
#define USE_CEI18N_ICU 0
#endif

#endif // __CESysTarget_linux_h__
