///////////////////////////////////////////////////////////////////////////////
// Copyright 2004,2009 Sony Corporation
///////////////////////////////////////////////////////////////////////////////

#ifndef __CESysTargetXai_h__
#define __CESysTargetXai_h__


/////////////////////////////////////////////
// Compiler
/////////////////////////////////////////////

#define CESYS_COMPILER_H "CESysCompilerGCC.h"


/////////////////////////////////////////////
// Existing C/C++ header files
/////////////////////////////////////////////

// included in CESysDefs.h
#define CE_HAVE_STDDEF_H 1
#define CE_HAVE_STDINT_H 1
#define CE_HAVE_LIMITS_H 1
#define CE_HAVE_STDARG_H 1

#define CE_HAVE_CTYPE_H 1
#define CE_HAVE_STRING_H 1
#define CE_HAVE_STDIO_H 1
#define CE_HAVE_STDLIB_H 1
#define CE_HAVE_FLOAT_H 1
#define CE_HAVE_MATH_H 1
#define CE_HAVE_MALLOC_H 0
#define CE_HAVE_NEW 1

#define CE_HAVE_STRCASECMP 1
#define CE_HAVE_LROUND 1


/////////////////////////////////////////////
// OS-dependent definitions
/////////////////////////////////////////////

#define CESYS_OSDEFS_H "CESysOSDefsXai.h"


////////////////////////////////////////////////
//  Syswrap System Dependent Header Files
////////////////////////////////////////////////

#define CESYSASSERT_TARGET_H "CESysAssertXai.h"
#define CESYSATOMICOPS_TARGET_H "CESysAtomicOpsXai.h"
#define CESYSCONFIG_TARGET_H "CESysConfigXai.h"
#define CESYSCRITICALSECTION_TARGET_H "CESysCriticalSectionXai.h"
#define CESYSGETTIMEOFDAY_TARGET_H "CESysGetTimeOfDayXai.h"
#define CESYSINTERLOCKEDSLIST_TARGET_H "CESysInterlockedSListXai.h"
#define CESYSSOCKET_TARGET_H "CESysSocketXai.h"


/////////////////////////////////////////////
// Target-dependent features
/////////////////////////////////////////////

#define CE_USE_INTERNAL_PROFILER 0

/*!
* use i18n icu4c binding.
*/
#if !defined(USE_CEI18N_ICU)
#define USE_CEI18N_ICU 0
#endif

#endif // __CESysTargetXai_h__
